<?php
	//Podatki za dostop do baze (posreduje Datastudio)
	$server_URL = '';
	$database_name = '';
	$username = '';
	$password = '';

	//Login
	$url = $server_URL.'/fmi/data/v1/databases/'.$database_name.'/sessions';
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_URL, $url );
	curl_setopt( $ch, CURLOPT_CUSTOMREQUEST, "POST" );
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt( $ch, CURLOPT_POSTFIELDS, "" );
	curl_setopt( $ch, CURLOPT_HTTPHEADER, [
		'Content-Type: application/json',
		'Authorization: Basic ' . base64_encode( $username . ':' . $password )
	] );
	$result = curl_exec( $ch );
	curl_close( $ch );
	$json = json_decode($result);
	$token = $json->response->token;
	
	//Preverimo ali partner ze obstaja v sifrantu
	$url = $server_URL.'/fmi/data/v1/databases/'.$database_name.'/layouts/REST_PoslovniPartnerji/_find';
	$query = '
		{
			"query":
			[
				{
					"PoslovniPartner_Email":"\\"info@datastudio.si\\""
				}
			]
		}';
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_URL, $url );
	curl_setopt( $ch, CURLOPT_CUSTOMREQUEST, "POST" );
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt( $ch, CURLOPT_POSTFIELDS, $query );
	curl_setopt( $ch, CURLOPT_HTTPHEADER, [
		'Content-Type: application/json',
		'Authorization: Bearer ' . $token
	] );
	$result = curl_exec( $ch );
	curl_close( $ch );
	$json = json_decode($result);
	if( $json->messages[0]->code == 0) {
		$pp_id = $json->response->data[0]->fieldData->PoslovniPartner_ID;
	}
	else {
		//Dodamo novega partnerja v šifrant
		$url = $server_URL.'/fmi/data/v1/databases/'.$database_name.'/layouts/REST_PoslovniPartnerji/records';
		$record = '
			{
				"fieldData":
				{
					"PoslovniPartner_Naziv":"Test Naziv",
					"PoslovniPartner_Ulica":"Test ulica",
					"PoslovniPartner_PostnaStevika":"1000",
					"PoslovniPartner_Kraj":"Test LJ",
					"PoslovniPartner_Drzava":"SLOVENIJA",
					"PoslovniPartner_Email":"info@datastudio.si"
				}
			}';
		$ch = curl_init();
		curl_setopt( $ch, CURLOPT_URL, $url );
		curl_setopt( $ch, CURLOPT_CUSTOMREQUEST, "POST" );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt( $ch, CURLOPT_POSTFIELDS, $record );
		curl_setopt( $ch, CURLOPT_HTTPHEADER, [
			'Content-Type: application/json',
			'Authorization: Bearer ' . $token
		] );
		$result = curl_exec( $ch );
		curl_close( $ch );
		$json = json_decode($result);
		
		$url = $server_URL.'/fmi/data/v1/databases/'.$database_name.'/layouts/REST_PoslovniPartnerji/records/'.$json->response->recordId;
		$ch = curl_init();
		curl_setopt( $ch, CURLOPT_URL, $url );
		curl_setopt( $ch, CURLOPT_CUSTOMREQUEST, "GET" );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt( $ch, CURLOPT_POSTFIELDS, "" );
		curl_setopt( $ch, CURLOPT_HTTPHEADER, [
			'Content-Type: application/json',
			'Authorization: Bearer ' . $token
		] );
		$result = curl_exec( $ch );
		curl_close( $ch );
		$json = json_decode($result);
		$pp_id = $json->response->data[0]->fieldData->PoslovniPartner_ID;
	}

	//Dodamo glavo predracuna v bazo
	$url = $server_URL.'/fmi/data/v1/databases/'.$database_name.'/layouts/REST_Predracuni/records';
	$record = '
		{
			"fieldData":
			{
				"UI_key_PoslovniPartnerID":'.$pp_id.',
				"UI_key_ProdajalecAccount":"Test",
				"UI_key_SkladisceID":1
			}
		}';
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_URL, $url );
	curl_setopt( $ch, CURLOPT_CUSTOMREQUEST, "POST" );
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt( $ch, CURLOPT_POSTFIELDS, $record );
	curl_setopt( $ch, CURLOPT_HTTPHEADER, [
		'Content-Type: application/json',
		'Authorization: Bearer ' . $token
	] );
	$result = curl_exec( $ch );
	curl_close( $ch );
	$json = json_decode($result);
		
	$url = $server_URL.'/fmi/data/v1/databases/'.$database_name.'/layouts/REST_Predracuni/records/'.$json->response->recordId;
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_URL, $url );
	curl_setopt( $ch, CURLOPT_CUSTOMREQUEST, "GET" );
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt( $ch, CURLOPT_POSTFIELDS, "" );
	curl_setopt( $ch, CURLOPT_HTTPHEADER, [
		'Content-Type: application/json',
		'Authorization: Bearer ' . $token
	] );
	$result = curl_exec( $ch );
	curl_close( $ch );
	$json = json_decode($result);
	$prac_id = $json->response->data[0]->fieldData->Predracun_ID;
	
	//dodamo postavke predracuna
	$url = $server_URL.'/fmi/data/v1/databases/'.$database_name.'/layouts/REST_PredracuniLineItems/records';
	$record = '
		{
			"fieldData":
			{
				"UI_key_PredracunID":'.$prac_id.',
				"UI_key_PoslovniPartnerID":'.$pp_id.',
				"UI_key_ArtikelID":1000
			}
		}';
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_URL, $url );
	curl_setopt( $ch, CURLOPT_CUSTOMREQUEST, "POST" );
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt( $ch, CURLOPT_POSTFIELDS, $record );
	curl_setopt( $ch, CURLOPT_HTTPHEADER, [
		'Content-Type: application/json',
		'Authorization: Bearer ' . $token
	] );
	$result = curl_exec( $ch );
	curl_close( $ch );
	$json = json_decode($result);
	
	$url = $server_URL.'/fmi/data/v1/databases/'.$database_name.'/layouts/REST_PredracuniLineItems/records';
	$record = '
		{
			"fieldData":
			{
				"UI_key_PredracunID":'.$prac_id.',
				"UI_key_PoslovniPartnerID":'.$pp_id.',
				"UI_key_ArtikelID":1000
			}
		}';
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_URL, $url );
	curl_setopt( $ch, CURLOPT_CUSTOMREQUEST, "POST" );
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt( $ch, CURLOPT_POSTFIELDS, $record );
	curl_setopt( $ch, CURLOPT_HTTPHEADER, [
		'Content-Type: application/json',
		'Authorization: Bearer ' . $token
	] );
	$result = curl_exec( $ch );
	curl_close( $ch );
	$json = json_decode($result);

	$url = $server_URL.'/fmi/data/v1/databases/'.$database_name.'/layouts/REST_PredracuniLineItems/records';
	$record = '
		{
			"fieldData":
			{
				"UI_key_PredracunID":'.$prac_id.',
				"UI_key_PoslovniPartnerID":'.$pp_id.',
				"UI_key_ArtikelID":1000,
				"PredracunLineItem_ProdajnaCenaBrezDavka":25.12
			}
		}';
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_URL, $url );
	curl_setopt( $ch, CURLOPT_CUSTOMREQUEST, "POST" );
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt( $ch, CURLOPT_POSTFIELDS, $record );
	curl_setopt( $ch, CURLOPT_HTTPHEADER, [
		'Content-Type: application/json',
		'Authorization: Bearer ' . $token
	] );
	$result = curl_exec( $ch );
	curl_close( $ch );
	$json = json_decode($result);

	//Sprozimo zakljucek narocila
	$url = $server_URL.'/fmi/data/v1/databases/'.$database_name.'/layouts/REST_Predracuni/script/REST_ZakljuciSpletnoNarocilo?script.param='.$prac_id;
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_URL, $url );
	curl_setopt( $ch, CURLOPT_CUSTOMREQUEST, "GET" );
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt( $ch, CURLOPT_POSTFIELDS, "" );
	curl_setopt( $ch, CURLOPT_HTTPHEADER, [
		'Content-Type: application/json',
		'Authorization: Bearer ' . $token
	] );
	$result = curl_exec( $ch );
	curl_close( $ch );
	$json = json_decode($result);
	print_r($json);

	//Logout (brez logout klica, seja ostane aktivna 15 minut od zadnjega klica)
	$url = $server_URL.'/fmi/data/v1/databases/'.$database_name.'/sessions/'.$token;
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_URL, $url );
	curl_setopt( $ch, CURLOPT_CUSTOMREQUEST, "DELETE" );
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt( $ch, CURLOPT_POSTFIELDS, "" );
	curl_setopt( $ch, CURLOPT_HTTPHEADER, [
		'Content-Type: application/json'
	] );
	$result = curl_exec( $ch );
	curl_close( $ch );
?>