<?php
	//Podatki za dostop do baze (posreduje Datastudio)
	$server_URL = '';
	$database_name = '';
	$username = '';
	$password = '';
	$st_id = '';

	//Login
	$url = $server_URL.'/fmi/data/v1/databases/'.$database_name.'/sessions';
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_URL, $url );
	curl_setopt( $ch, CURLOPT_CUSTOMREQUEST, "POST" );
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt( $ch, CURLOPT_POSTFIELDS, "" );
	curl_setopt( $ch, CURLOPT_HTTPHEADER, [
		'Content-Type: application/json',
		'Authorization: Basic ' . base64_encode( $username . ':' . $password )
	] );
	$result = curl_exec( $ch );
	curl_close( $ch );
	$json = json_decode($result);
	$token = $json->response->token;
	
	//Sprozimo prenos narocil s spletne trgovine
	$url = $server_URL.'/fmi/data/v1/databases/'.$database_name.'/layouts/SpletneTrgovine/script/Woocommerce_PrenesiSpletnaNarocila?script.param='.$st_id;
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_URL, $url );
	curl_setopt( $ch, CURLOPT_CUSTOMREQUEST, "GET" );
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt( $ch, CURLOPT_POSTFIELDS, "" );
	curl_setopt( $ch, CURLOPT_HTTPHEADER, [
		'Content-Type: application/json',
		'Authorization: Bearer ' . $token
	] );
	$result = curl_exec( $ch );
	curl_close( $ch );
	$json = json_decode($result);
	print_r($json);


	//Logout (brez logout klica, seja ostane aktivna 15 minut od zadnjega klica)
	$url = $server_URL.'/fmi/data/v1/databases/'.$database_name.'/sessions/'.$token;
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_URL, $url );
	curl_setopt( $ch, CURLOPT_CUSTOMREQUEST, "DELETE" );
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt( $ch, CURLOPT_POSTFIELDS, "" );
	curl_setopt( $ch, CURLOPT_HTTPHEADER, [
		'Content-Type: application/json'
	] );
	$result = curl_exec( $ch );
	curl_close( $ch );
?>